package test;

import javax.jms.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Properties;

/**
 * @author prashant.saksena
 * @since 5/7/13
 */
public class HQReceiver {
    private Session session_;
    private MessageConsumer messageConsumer_;

    public HQReceiver() throws JMSException, NamingException {
        Properties p = new Properties();
        p.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY,
                "org.jnp.interfaces.NamingContextFactory");
        p.put(javax.naming.Context.URL_PKG_PREFIXES,
                "org.jboss.naming:org.jnp.interfaces");
        p.put(javax.naming.Context.PROVIDER_URL, "jnp://localhost:2009");
        InitialContext initialContext = new InitialContext(p);

        ConnectionFactory connectionFactory = (ConnectionFactory) initialContext.lookup("/ConnectionFactory");
        Connection connection = connectionFactory.createConnection();
        session_ = connection.createSession(true, Session.SESSION_TRANSACTED);
        Queue testQueue = (Queue) initialContext.lookup("queue/testQueue");
        messageConsumer_ = session_.createConsumer(testQueue);
        MessageListener messageListener = new MessageListener() {
            public void onMessage(Message message) {
                try {
                    String msg = ((ObjectMessage) message).getObject().toString();
                    System.out.println("Message: " + msg);
                    session_.commit();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        };
        messageConsumer_.setMessageListener(messageListener);
        connection.start();
    }

    public static void main(String[] args) throws Exception {
        HQReceiver receiver = new HQReceiver();
        System.out.println("Started receiver ................");

        while (true) {
            Thread.sleep(1000000);
        }
    }
}
